Open Mode in EJ2 JavaScript Tooltip

21 Aug 202622 minutes to read

You can decide the mode on which the Tooltip is to be opened on a page, i.e., on hovering, focusing, or clicking on the target elements.

On mobile devices, Tooltips appear when you tap and hold the element, even if the opensOn option is assigned with Hover. Tooltips are also displayed as long as you continue to tap and hold the element. On lift, it disappears in the next 1.5 seconds. If there is another action before that time ends, then the Tooltip disappears.

The opensOn property can take either a single or a combination of multiple values, separated by space, from the following options. The table below explains how the Tooltip opens on both desktop and mobile based on the value(s) assigned to the opensOn property. By default, it takes the auto value.

Values Desktop Mobile
Auto Tooltip appears when you hover over the target or when the target element receives the focus. Tooltip opens on tap and hold of the target element.
Hover Tooltip appears when you hover over the target. Tooltip opens on tap and hold of the target element.
Click Tooltip appears when you click a target element. Tooltip appears when you single tap the target element.
Focus Tooltip appears when you focus (say through the tab key) on a target element. Tooltip appears with a single tap on the target element.
Custom Tooltip is not triggered by any default action. So, you have to bind your own events and use either open or close public methods. Same as Desktop.

To open the Tooltip for multiple actions, say while hovering over or clicking on a target element, the opensOn property can be assigned with multiple values, separated by space as Hover Click.

The auto value cannot be used in combination for multiple values.

The following code example shows how to set the open mode for Tooltips.

var hoverTooltip = new ej.popups.Tooltip({
    opensOn: 'Hover',
    content: 'Tooltip from hover'
});
hoverTooltip.appendTo('#tooltiphover');

var button = new ej.buttons.Button();
button.appendTo('#tooltiphover');


var clickTooltip = new ej.popups.Tooltip({
    opensOn: 'Click',
    content: 'Tooltip from click'
});
clickTooltip.appendTo('#tooltipclick');
button.appendTo('#tooltipclick');

var focusTooltip = new ej.popups.Tooltip({
    opensOn: 'Focus',
    content: 'Tooltip from focus'
});
focusTooltip.appendTo('#tooltipfocus');

var customTooltip = new ej.popups.Tooltip({
    opensOn: 'Custom',
    content: 'Tooltip from custom mode'
});
customTooltip.appendTo('#tooltipcustom');
button.appendTo('#tooltipopen');

document.getElementById('tooltipopen').addEventListener("click", function () {
    if (this.getAttribute("data-tooltip-id")) {
        customTooltip.close();
    } else {
        customTooltip.open(this);
    }
});
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Tooltip</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <table style="margin: 150px auto 0 auto;transform: translateY(-50%);">
            <tbody>
                <tr>
                    <td style="padding:25px">
                        <div id="tooltiphover" class="blocks">
                            <span>Hover Me !(Default)</span>
                        </div>
                    </td>
                    <td style="padding:25px">
                        <div id="tooltipclick" class="blocks">
                            <span>Click Me !</span>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td style="padding:25px">
                        <div class="">
                            <span id="textbox" class="e-float-input">
                                <input id="tooltipfocus" type="text" placeholder="Focus and blur">
                            </span>
                        </div>
                    </td>
                    <td style="padding:25px">
                        <div id="tooltipcustom">
                            <div>
                                <input id="tooltipopen" type="button" value="Click to open tooltip manually">
                            </div>
                        </div>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        .blocks {
            width: 260px;
        }
    </style>
</body>

</html>
#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

Custom open mode

Other than the specified options, the custom mode allows the Tooltip to appear on-screen for user-defined custom actions such as right-click, double-click, and so on. In this mode, the Tooltip is not triggered by any default action; you must bind your own events and use either open or close public methods to show or hide the Tooltips.

The following code example shows how to define a custom open mode for the Tooltip.

var tooltip = new ej.popups.Tooltip({
    opensOn: 'Custom',
    content: 'Tooltip from custom mode'
});
tooltip.appendTo('#box');
document.getElementById('box').addEventListener("dblclick", function () {
    if (this.getAttribute("data-tooltip-id")) {
        tooltip.close();
    }
    else {
        tooltip.open(this);
    }
});
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Tooltip</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="box">
            Double-click to open Tooltip.
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        #box {
            background-color: #cfd8dc;
            border: 3px solid #eceff1;
            box-sizing: border-box;
            margin: 80px auto;
            padding: 20px 0;
            width: 300px;
            text-align: center;
            color: #424242;
            font-size: 20px;
            user-select: none;
        }
    </style>
</body>

</html>
#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

Sticky mode

With this mode set to true, Tooltips can be made to stay on the screen as long as the close icon is pressed. In this mode, a close icon is attached at the top right corner of the Tooltip. This mode can be enabled or disabled using the isSticky property.

var tooltip = new ej.popups.Tooltip({
    isSticky: true,
    content: 'Click close icon to close me'
});
tooltip.appendTo('#target');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Tooltip</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="target">
            Show tooltip
        </div>
    </div>
    
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        #target {
            background-color: #cfd8dc;
            border: 3px solid #eceff1;
            box-sizing: border-box;
            margin: 80px auto;
            padding: 20px 0;
            width: 200px;
            text-align: center;
            color: #424242;
            font-size: 20px;
            user-select: none;
        }
    </style>
</body>

</html>
#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

Open/Close Tooltip with delay

Tooltip can be opened or closed after some delay by using the openDelay and closeDelay properties.

var tooltip = new ej.popups.Tooltip({
    openDelay: 1000,
    closeDelay: 1000,
    content: 'Tooltip with delay'
});
tooltip.appendTo('#target');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Tooltip</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="target">
            Show tooltip
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        #target {
            background-color: #cfd8dc;
            border: 3px solid #eceff1;
            box-sizing: border-box;
            margin: 80px auto;
            padding: 20px 0;
            width: 200px;
            text-align: center;
            color: #424242;
            font-size: 20px;
            user-select: none;
        }
    </style>
</body>

</html>
#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

Open Mode in React Tooltip

The mode in which the React Tooltip opens on a page can be specified by setting the open mode to hovering, focusing, or clicking on target elements.

On mobile devices, React Tooltips appear when you tap and hold the element, even if the opensOn option is assigned with Hover.
Tooltips are also displayed as long as you continue to tap and hold the element. When you release your finger, it disappears after 1.5 seconds.
If there is another action before that time ends, then the React Tooltip disappears.

The opensOn property can take either a single or a combination of multiple values, separated by space from the following options.
The table below explains how the React Tooltip opens on both desktop and mobile based on the value(s) assigned to the opensOn property.
By default, it takes Auto value.

Values Desktop Mobile
Auto React Tooltip appears when you hover over the target or when the target element receives the focus. React Tooltip opens on tap and hold of the target element.
Hover React Tooltip appears when you hover over the target. React Tooltip opens on tap and hold of the target element.
Click React Tooltip appears when you click a target element. React Tooltip appears when you single tap the target element.
Focus React Tooltip appears when you focus (say through tab key) on a target element. React Tooltip appears with a single tap on the target element.
Custom React Tooltip is not triggered by any default action. So, you have to bind your own events and use either open or close public methods. Same as Desktop.

To open the React Tooltip for multiple actions, say while hovering over or clicking on a target element, the opensOn property can be assigned with multiple values, separated by space as hover click.

Auto value cannot be used with any combination for multiple values.

The following code example shows how to set the open mode for Tooltips.

import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';
function App() {
    let buttonElement;
    let tooltipInstance;
    function handleClick() {
        if (buttonElement.getAttribute('data-tooltip-id')) {
            tooltipInstance.close();
        }
        else {
            tooltipInstance.open(buttonElement);
        }
    }
    ;
    let style = {
        margin: '150px auto 0 auto', transform: 'translateY(-50%)'
    };
    let margin = {
        margin: '40px'
    };
    return (<div id='container'>
        <table style={style}>
            <tbody>
                <tr>
                    <td>
                        <TooltipComponent content='Tooltip from hover' opensOn='Hover' target='#hoverButton'>
                            <button style={margin} id='hoverButton' className="e-btn blocks">Hover Me !(Default)</button>
                        </TooltipComponent>
                    </td>
                    <td>
                        <TooltipComponent content='Tooltip from click' opensOn='Click' target='#clickButton'>
                            <button style={margin} id='clickButton' className="e-btn blocks">Click Me !</button>
                        </TooltipComponent>
                    </td>
                </tr>
                <tr>
                    <td>
                        <TooltipComponent content='Tooltip from focus' opensOn='Focus' target='#tooltipfocus'>
                            <span style={margin} id="textbox" className="e-float-input blocks">
                                <input id="tooltipfocus" type="text" placeholder="Focus and blur" />
                            </span>
                        </TooltipComponent>
                    </td>
                    <td>
                        <TooltipComponent className="wrap" ref={t => tooltipInstance = t} opensOn='custom' content='Tooltip from custom mode'>
                            <input id="box" type="button" className="e-btn" ref={d => buttonElement = d} onClick={handleClick.bind(this)} value="Click to open Tooltip manually" />
                        </TooltipComponent>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';

function App() {
    let buttonElement: HTMLElement;
    let tooltipInstance: TooltipComponent;
    function handleClick(): void {
        if (buttonElement.getAttribute('data-tooltip-id')) {
            tooltipInstance.close();
        } else {
            tooltipInstance.open(buttonElement);
        }
    };
    let style: object = {
        margin: '150px auto 0 auto', transform: 'translateY(-50%)'
    };
    let margin: object = {
        margin: '40px'
    };
    return (
        <div id='container'>
            <table style={style}>
                <tbody>
                    <tr>
                        <td>
                            <TooltipComponent content='Tooltip from hover' opensOn='Hover' target='#hoverButton'>
                                <button style={margin} id='hoverButton' className="e-btn blocks">Hover Me !(Default)</button>
                            </TooltipComponent>
                        </td>
                        <td>
                            <TooltipComponent content='Tooltip from click' opensOn='Click' target='#clickButton'>
                                <button style={margin} id='clickButton' className="e-btn blocks">Click Me !</button>
                            </TooltipComponent>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <TooltipComponent content='Tooltip from focus' opensOn='Focus' target='#tooltipfocus'>
                                <span style={margin} id="textbox" className="e-float-input blocks">
                                    <input id="tooltipfocus" type="text" placeholder="Focus and blur" />
                                </span>
                            </TooltipComponent>
                        </td>
                        <td>
                            <TooltipComponent className="wrap" ref={t => tooltipInstance = t} opensOn='custom' content='Tooltip from custom mode'>
                                <input id="box" type="button" className="e-btn" ref={d => buttonElement = d} onClick={handleClick.bind(this)} value="Click to open Tooltip manually" />
                            </TooltipComponent>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    );
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.blocks {
    width: 260px;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tooltip</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='sample'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Custom open mode

Other than the above specified options, the custom mode makes the React Tooltip appear on screen for user-defined custom actions such as right-click, double-click, and so on. In this mode, the React Tooltip is not triggered by any default action, and you have to bind your own events and use either open or close public methods to show or hide the Tooltips.

The following code example shows how to define custom open mode for the React Tooltip.

import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';
function App() {
    let buttonElement;
    let tooltipInstance;
    function handleDoubleClick() {
        if (buttonElement.getAttribute('data-tooltip-id')) {
            tooltipInstance.close();
        }
        else {
            tooltipInstance.open(buttonElement);
        }
    }
    ;
    return (<TooltipComponent className="wrap" ref={t => tooltipInstance = t} opensOn='custom' content='Tooltip from custom mode'>
        <input id="box" type="button" ref={d => buttonElement = d} onDoubleClick={handleDoubleClick.bind(this)} value="Double click to open tooltip" />
    </TooltipComponent>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';

function App() {
    let buttonElement: HTMLElement;
    let tooltipInstance: TooltipComponent;
    function handleDoubleClick(): void {
        if (buttonElement.getAttribute('data-tooltip-id')) {
            tooltipInstance.close();
        } else {
            tooltipInstance.open(buttonElement);
        }
    };
    return (
        <TooltipComponent className="wrap" ref={t => tooltipInstance = t} opensOn='custom' content='Tooltip from custom mode'>
            <input id="box" type="button" ref={d => buttonElement = d} onDoubleClick={handleDoubleClick.bind(this)} value="Double click to open tooltip" />
        </TooltipComponent>
    );
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

#box {
    background-color: #cfd8dc;
    border: 3px solid #eceff1;
    box-sizing: border-box;
    margin: 80px auto;
    padding: 20px 0;
    width: 300px;
    text-align: center;
    color: #424242;
    font-size: 20px;
    user-select: none;
    display: block;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tooltip</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='sample'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Sticky mode

When this mode is set to true, Tooltips remain visible on the screen until the close icon is pressed. In this mode, a close icon is attached to the React Tooltip, located at the top right corner. This mode can be enabled or disabled using the isSticky property.

import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';
function App() {
    return (<TooltipComponent className="tooltip-box" isSticky={true} content='Click close icon to close me'>
        <div id='target'>Show Tooltip</div>
    </TooltipComponent>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';

function App() {
  return (
    <TooltipComponent className="tooltip-box" isSticky={true} content='Click close icon to close me'>
      <div id='target'>Show Tooltip</div>
    </TooltipComponent>
  );
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

#target {
    background-color: #cfd8dc;
    border: 3px solid #eceff1;
    box-sizing: border-box;
    margin: 80px auto;
    padding: 20px 0;
    width: 200px;
    text-align: center;
    color: #424242;
    font-size: 20px;
    user-select: none;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tooltip</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='sample'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Open/Close Tooltip with delay

The React Tooltips can be opened or closed after a specified delay by using the openDelay and closeDelay properties.

import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';
function App() {
    return (<TooltipComponent className="tooltip-box" content='Tooltip with delay' openDelay={1000} closeDelay={1000}>
        <div id='target'>Show Tooltip</div>
    </TooltipComponent>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';

function App() {
  return (
    <TooltipComponent className="tooltip-box" content='Tooltip with delay' openDelay={1000} closeDelay={1000}>
      <div id='target'>Show Tooltip</div>
    </TooltipComponent>
  );
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

#target {
    background-color: #cfd8dc;
    border: 3px solid #eceff1;
    box-sizing: border-box;
    margin: 80px auto;
    padding: 20px 0;
    width: 200px;
    text-align: center;
    color: #424242;
    font-size: 20px;
    user-select: none;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tooltip</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='sample'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Open mode in Angular Tooltip

26 Sep 202614 minutes to read

Control how the Angular Tooltip opens on the page—on hover, focus, or click—using the opensOn property on target elements.

On mobile devices, Angular Tooltip appear when you tap and hold the element, even if the opensOn option is assigned with Hover.
Angular Tooltip are also displayed as long as you continue to tap and hold the element. On release, it disappears after 1.5 seconds.
If there is another action before that time ends, then the Angular Tooltip disappears.

The opensOn property accepts either a single value or multiple values separated by a space. The table below explains how the Angular Tooltip opens on desktop and mobile based on the opensOn property value. By default, it is set to Auto.

Values Desktop Mobile
Auto Tooltip appears on hover or focus. Tooltip opens on tap and hold.
Hover Tooltip appears on hover. Tooltip opens on tap and hold.
Click Tooltip appears on click. Tooltip appears on single tap.
Focus Tooltip appears on focus (e.g., through Tab key). Tooltip appears on single tap.
Custom Tooltip is not triggered by default. Bind your own events and use the open or close methods. Same as Desktop.

To open the Angular Tooltip on multiple actions (e.g., hover or click), assign the opensOn property with multiple space-separated values, such as hover click.

The Auto value cannot be combined with other values.

The following code example demonstrates how to set the open mode for Angular Tooltip.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TooltipModule } from '@syncfusion/ej2-angular-popups'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { Component, ViewChild } from '@angular/core';
import { TooltipComponent } from '@syncfusion/ej2-angular-popups';

@Component({
  imports: [
    TooltipModule,
    ButtonModule
  ],
  standalone: true,
  selector: 'my-app',
  template: `
    <div id='container'>
        <table style="margin: 150px auto 0 auto;transform: translateY(-50%);">
            <tbody>
                <tr>
                    <td style="padding:25px">
                      <ejs-tooltip id="tooltipHover" opensOn='Hover' content='Tooltip from hover' >
                       <div>
                        <input ejs-button  class="blocks" type="button" value="Hover Me!"/></div>
                      </ejs-tooltip>
                    </td>
                    <td style="padding:25px">
                      <ejs-tooltip id="tooltipClick"  opensOn='Click' content='Tooltip from click'>
                       <div>
                        <input ejs-button  class="blocks" type="button" value="Click Me!"/></div>
                      </ejs-tooltip>
                    </td>
                </tr>
                <tr>
                    <td style="padding:25px">
                      <ejs-tooltip id="tooltipFocus" opensOn='Focus' content='Tooltip from focus' target='#input'>
                         <div>
                          <input id='input' class="blocks e-float-input" type="text" placeholder="Focus and blur"/>
                        </div>
                      </ejs-tooltip>
                    </td>
                    <td style="padding:25px">
                      <ejs-tooltip id="tooltipCustom" #tooltipCustom opensOn='custom' content='Tooltip from custom mode'>
                        <div>
                          <input ejs-button  class="blocks" id="tooltipOpen" type="button" value="Click to open tooltip manually" (click)='onCustomOpen($event)'/>
                        </div>
                      </ejs-tooltip>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
    `,
  styles: [`
    .blocks {
        width: 260px;
    }
    `]
})

export class AppComponent {
  @ViewChild('tooltipCustom')
  public tooltipCustom: TooltipComponent | any;
  constructor() { }
  onCustomOpen(args: any): void {
    if (args.target.getAttribute('data-tooltip-id')) {
      this.tooltipCustom.close();
    } else {
      this.tooltipCustom.open(args.target);
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Custom open mode

The custom mode allows the Angular Tooltip to appear on user-defined custom actions such as right-click or double-click. The Angular Tooltip is not triggered by any default action. Bind your own events and use the open or close methods to show or hide the Angular Tooltip.

The following code example demonstrates how to define custom open mode for the Angular Tooltip.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TooltipModule } from '@syncfusion/ej2-angular-popups'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { Component, ViewChild } from '@angular/core';
import { TooltipComponent } from '@syncfusion/ej2-angular-popups';

@Component({
    imports: [
        TooltipModule,
        ButtonModule
    ],
    standalone: true,
    selector: 'my-app',
    template: `
    <ejs-tooltip #tooltip id="tooltip" content='Tooltip from custom mode' opensOn='Custom' (dblclick)='customOpen($event)'>
            <span>Double-click to open Tooltip</span>
    </ejs-tooltip>
    `,
    styles: [`
    #tooltip {
        display: block;
        background-color: #cfd8dc;
        border: 3px solid #eceff1;
        box-sizing: border-box;
        margin: 80px auto;
        padding: 20px 0;
        width: 200px;
        text-align: center;
        color: #424242;
        font-size: 20px;
    }
    `]
})

export class AppComponent {
    @ViewChild('tooltip')
    public tooltipControl: TooltipComponent | any;
    constructor() { }
    customOpen(args: any): void {
        if (args.target.getAttribute("data-tooltip-id")) {
            this.tooltipControl.close();
        } else {
            this.tooltipControl.open(args.target);
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Sticky mode

Enable sticky mode to keep the tooltip on the screen until you click the close icon. In this mode, the close icon appears in the top right corner of the tooltip. Enable or disable sticky mode using the isSticky property.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TooltipModule } from '@syncfusion/ej2-angular-popups'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { Component } from '@angular/core';

@Component({
    imports: [
        TooltipModule,
        ButtonModule
    ],
    standalone: true,
    selector: 'my-app',
    template: `
    <ejs-tooltip id="tooltip" content='Click close icon to close me' [isSticky]='true'>
            <span>Show tooltip</span>
    </ejs-tooltip>
    `,
    styles: [`
    #tooltip {
        display: block;
        background-color: #cfd8dc;
        border: 3px solid #eceff1;
        box-sizing: border-box;
        margin: 80px auto;
        padding: 20px 0;
        width: 200px;
        text-align: center;
        color: #424242;
        font-size: 20px;
    }
    `]
})

export class AppComponent {
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Open/Close Tooltip with delay

Delay Angular Tooltip opening or closing using the openDelay and closeDelay properties.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TooltipModule } from '@syncfusion/ej2-angular-popups'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { Component } from '@angular/core';

@Component({
    imports: [
        TooltipModule,
        ButtonModule
    ],
    standalone: true,
    selector: 'my-app',
    template: `
    <ejs-tooltip id="tooltip" content='Tooltip with delay' [openDelay]='1000' [closeDelay]='1000'>
            Show tooltip
    </ejs-tooltip>
    `,
    styles: [`
    #tooltip {
        display: block;
        background-color: #cfd8dc;
        border: 3px solid #eceff1;
        box-sizing: border-box;
        margin: 80px auto;
        padding: 20px 0;
        width: 200px;
        text-align: center;
        color: #424242;
        font-size: 20px;
    }
    `]
})

export class AppComponent {
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Open Mode in Vue Tooltip

20 Aug 202624 minutes to read

You can decide the mode in which the Tooltip opens on a page, i.e., on hovering, focusing, or clicking on the target elements.

On mobile devices, Tooltips appear when you tap and hold the element, even if the opensOn option is assigned with hover.
Tooltips are also displayed as long as you continue to tap and hold the element. On release, it disappears after 1.5 seconds.
If there is another action before this time elapses, the Tooltip disappears.

The opensOn property can take either a single or a combination of multiple values, separated by space from the following options. The table below explains how the Tooltip opens on both desktop and mobile based on the value(s) assigned to the opensOn property. By default, it takes auto value.

Values Desktop Mobile
Auto Tooltip appears when you hover over the target or when the target element receives the focus. Tooltip opens on tap and hold of the target element.
Hover Tooltip appears when you hover over the target. Tooltip opens on tap and hold of the target element.
Click Tooltip appears when you click a target element. Tooltip appears when you single tap the target element.
Focus Tooltip appears when you focus (say through tab key) on a target element. Tooltip appears with a single tap on the target element.
Custom Tooltip is not triggered by any default action. So, you have to bind your own events and use either open or close public methods. Same as Desktop.

To open the Tooltip for multiple actions, say while hovering over or clicking on a target element, the opensOn property can be assigned with multiple values, separated by space as Hover Click.

Auto value cannot be used with any combination for multiple values.

The following code example shows how to set the open mode for Tooltips.

<template>
    <div id='app'>
        <div id='container'>
            <ejs-tooltip id="tooltipHover" opensOn='Hover' content='Tooltip from hover' target="#tooltiphover">
                <ejs-tooltip target="#tooltipclick" id="tooltipClick" opensOn='Click' content='Tooltip from click'>
                    <ejs-tooltip target="#tooltipfocus" id="tooltipFocus" opensOn='Focus' content='Tooltip from focus'>
                        <ejs-tooltip target="#tooltipopen" ref="tooltip" opensOn='Custom'
                            content='Tooltip from custom mode'>
                            <table
                                style="margin-top: 50px;transform: translateX(-50%);position: relative;left: 50%;height: 250px;">
                                <tbody>
                                    <tr>
                                        <td style="padding:25px">
                                            <div id="tooltiphover" class="blocks e-btn">
                                                <span>Hover Me !(Default)</span>
                                            </div>
                                        </td>
                                        <td style="padding:25px">
                                            <div id="tooltipclick" class="blocks e-btn">
                                                <span>Click Me !</span>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td style="padding:25px">
                                            <div class="">
                                                <span id="textbox" class="e-float-input">
                                                    <input id="tooltipfocus" type="text" placeholder="Focus and blur" />
                                                </span>
                                            </div>
                                        </td>
                                        <td style="padding:25px">
                                            <div id="tooltipcustom">
                                                <div>
                                                    <input id="tooltipopen" type="button" class="e-btn"
                                                        value="Click to open tooltip manually" v-on:click="onCustomOpen" />
                                                </div>
                                            </div>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </ejs-tooltip>
                    </ejs-tooltip>
                </ejs-tooltip>
            </ejs-tooltip>
        </div>
    </div>
</template>

<script setup>
import { TooltipComponent as EjsTooltip } from "@syncfusion/ej2-vue-popups";
import { ref } from 'vue';

const tooltip = ref(null);

const onCustomOpen = (args) => {
    if (args.target.getAttribute('data-tooltip-id')) {
        tooltip.value.close();
    } else {
        tooltip.value.open(args.target);
    }
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

.blocks {
    width: 260px;
}
</style>
<template>
    <div id='app'>
        <div id='container'>
            <ejs-tooltip id="tooltipHover" opensOn='Hover' content='Tooltip from hover' target="#tooltiphover">
                <ejs-tooltip target="#tooltipclick" id="tooltipClick" opensOn='Click' content='Tooltip from click'>
                    <ejs-tooltip target="#tooltipfocus" id="tooltipFocus" opensOn='Focus' content='Tooltip from focus'>
                        <ejs-tooltip target="#tooltipopen" ref="tooltip" opensOn='Custom'
                            content='Tooltip from custom mode'>
                            <table
                                style="margin-top: 50px;transform: translateX(-50%);position: relative;left: 50%;height: 250px;">
                                <tbody>
                                    <tr>
                                        <td style="padding:25px">
                                            <div id="tooltiphover" class="blocks e-btn">
                                                <span>Hover Me !(Default)</span>
                                            </div>
                                        </td>
                                        <td style="padding:25px">
                                            <div id="tooltipclick" class="blocks e-btn">
                                                <span>Click Me !</span>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td style="padding:25px">
                                            <div class="">
                                                <span id="textbox" class="e-float-input">
                                                    <input id="tooltipfocus" type="text" placeholder="Focus and blur" />
                                                </span>
                                            </div>
                                        </td>
                                        <td style="padding:25px">
                                            <div id="tooltipcustom">
                                                <div>
                                                    <input id="tooltipopen" type="button" class="e-btn"
                                                        value="Click to open tooltip manually" v-on:click="onCustomOpen" />
                                                </div>
                                            </div>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </ejs-tooltip>
                    </ejs-tooltip>
                </ejs-tooltip>
            </ejs-tooltip>
        </div>
    </div>
</template>

<script>
import { TooltipComponent } from "@syncfusion/ej2-vue-popups";

export default {
    name: "App",
    components: {
        "ejs-tooltip": TooltipComponent
    },
    data: function () {
        return {
        };
    },
    methods: {
        onCustomOpen: function (args) {
            if (args.target.getAttribute('data-tooltip-id')) {
                this.$refs.tooltip.close();
            } else {
                this.$refs.tooltip.open(args.target);
            }
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

.blocks {
    width: 260px;
}
</style>

Custom open mode

Other than the above specified options, the custom mode makes the Tooltip appear on screen for user-defined custom actions, such as right-click, double-click, and so on. Here, the Tooltip is not triggered by any default action, and you have to bind your own events and use either open or close public methods to show or hide the Tooltips.

The following code example shows how to define custom open mode for the Tooltip.

<template>
    <div id='app'>
        <ejs-tooltip ref="tooltip" id="tooltip" content='Tooltip from custom mode' opensOn='Custom'
            v-on:dblclick='customOpen'>
            <div id="box">Double-click to open Tooltip.</div>
        </ejs-tooltip>
    </div>
</template>

<script setup>
import { TooltipComponent as EjsTooltip } from "@syncfusion/ej2-vue-popups";
import { ref } from 'vue';

const tooltip = ref(null);

const customOpen = (args) => {
    if (args.target.getAttribute('data-tooltip-id')) {
        tooltip.value.close();
    } else {
        tooltip.value.open(args.target);
    }
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#box {
    background-color: #cfd8dc;
    border: 3px solid #eceff1;
    box-sizing: border-box;
    margin: 80px auto;
    padding: 20px 0;
    width: 300px;
    text-align: center;
    color: #424242;
    font-size: 20px;
    user-select: none;
}
</style>
<template>
    <div id='app'>
        <ejs-tooltip ref="tooltip" id="tooltip" content='Tooltip from custom mode' opensOn='Custom'
            v-on:dblclick='customOpen'>
            <div id="box">Double-click to open Tooltip.</div>
        </ejs-tooltip>
    </div>
</template>

<script>
import { TooltipComponent } from "@syncfusion/ej2-vue-popups";

export default {
    name: "App",
    components: {
        "ejs-tooltip": TooltipComponent
    },
    data: function () {
        return {
        };
    },
    methods: {
        customOpen: function (args) {
            if (args.target.getAttribute('data-tooltip-id')) {
                this.$refs.tooltip.close();
            } else {
                this.$refs.tooltip.open(args.target);
            }
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#box {
    background-color: #cfd8dc;
    border: 3px solid #eceff1;
    box-sizing: border-box;
    margin: 80px auto;
    padding: 20px 0;
    width: 300px;
    text-align: center;
    color: #424242;
    font-size: 20px;
    user-select: none;
}
</style>

Sticky mode

With this mode set to true, Tooltips remain on the screen until the close icon is pressed. In this mode, close icon is attached to the Tooltip located at the top right corner. This mode can be enabled or disabled using the isSticky property.

<template>
  <div id='app'>
    <ejs-tooltip id="tooltip" content='Click close icon to close me' isSticky='true'>
      <div id="target">
        Show tooltip
      </div>
    </ejs-tooltip>
  </div>
</template>

<script setup>
import { TooltipComponent as EjsTooltip } from "@syncfusion/ej2-vue-popups";

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#target {
  background-color: #cfd8dc;
  border: 3px solid #eceff1;
  box-sizing: border-box;
  margin: 80px auto;
  padding: 20px 0;
  width: 200px;
  text-align: center;
  color: #424242;
  font-size: 20px;
  user-select: none;
}
</style>
<template>
   <div id='app'>
        <ejs-tooltip id="tooltip" content='Click close icon to close me' isSticky='true'>
            <div id="target">
                Show tooltip
            </div>
    </ejs-tooltip>
    </div>
</template>
<script>
import { TooltipComponent } from "@syncfusion/ej2-vue-popups";

export default {
name: "App",
components: {
"ejs-tooltip":TooltipComponent
},
  data: function() {
    return {
    };
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
#target {
    background-color: #cfd8dc;
    border: 3px solid #eceff1;
    box-sizing: border-box;
    margin: 80px auto;
    padding: 20px 0;
    width: 200px;
    text-align: center;
    color: #424242;
    font-size: 20px;
    user-select: none;
}
</style>

Open/Close Tooltip with delay

The Tooltips can be opened or closed after some delay by using the openDelay and closeDelay properties.

<template>
  <div id='app'>
    <ejs-tooltip id="tooltip" content='Tooltip with delay' openDelay='1000' closeDelay='1000'>
      <div id="target">
        Show tooltip
      </div>
    </ejs-tooltip>
  </div>
</template>
<script setup>
import { TooltipComponent as EjsTooltip } from "@syncfusion/ej2-vue-popups";

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#target {
  background-color: #cfd8dc;
  border: 3px solid #eceff1;
  box-sizing: border-box;
  margin: 80px auto;
  padding: 20px 0;
  width: 200px;
  text-align: center;
  color: #424242;
  font-size: 20px;
  user-select: none;
}
</style>
<template>
  <div id='app'>
    <ejs-tooltip id="tooltip" content='Tooltip with delay' openDelay='1000' closeDelay='1000'>
      <div id="target">
        Show tooltip
      </div>
    </ejs-tooltip>
  </div>
</template>

<script>
import { TooltipComponent } from "@syncfusion/ej2-vue-popups";

export default {
  name: "App",
  components: {
    "ejs-tooltip": TooltipComponent
  },
  data: function () {
    return {
    };
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#target {
  background-color: #cfd8dc;
  border: 3px solid #eceff1;
  box-sizing: border-box;
  margin: 80px auto;
  padding: 20px 0;
  width: 200px;
  text-align: center;
  color: #424242;
  font-size: 20px;
  user-select: none;
}
</style>